// MiscInfoPage.cpp : implementation file
//

#include "stdafx.h"
#include "SystemApplication.h"
#include "MiscInfoPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MiscInfoPage property page

IMPLEMENT_DYNCREATE(MiscInfoPage, CPropertyPage)

MiscInfoPage::MiscInfoPage() : CPropertyPage(MiscInfoPage::IDD)
{
	//{{AFX_DATA_INIT(MiscInfoPage)
	m_bstrComputerName = NULL;
	m_bstrUserName = NULL;
	m_bstrLocalLanguage = NULL;
	//}}AFX_DATA_INIT
}

MiscInfoPage::~MiscInfoPage()
{
	::SysFreeString (m_bstrComputerName);
	::SysFreeString (m_bstrUserName);
	::SysFreeString (m_bstrLocalLanguage);
}

void MiscInfoPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MiscInfoPage)
	DDX_Control(pDX, IDC_MISC_INFO_LIST, m_ListCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MiscInfoPage, CPropertyPage)
	//{{AFX_MSG_MAP(MiscInfoPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MiscInfoPage message handlers

BOOL MiscInfoPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	if (FAILED (m_pSystemInfo->GetComputerName (&m_bstrComputerName))) {
		return FALSE;
	}

	if (FAILED (m_pSystemInfo->GetUserName (&m_bstrUserName))) {
		return FALSE;
	}

	if (FAILED (m_pSystemInfo->GetLocalLanguage (&m_bstrLocalLanguage))) {
		return FALSE;
	}
	
	SetListData();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void MiscInfoPage::SetListData()
{
	CString tmpStr = _T ("");
	LV_ITEM item;
	LV_COLUMN leftCol, rightCol;

	leftCol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	leftCol.fmt = LVCFMT_LEFT;
	leftCol.iSubItem = 0;
	leftCol.cx = 130;
	leftCol.pszText = _T ("Variable");

	rightCol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	rightCol.fmt = LVCFMT_LEFT;
	rightCol.iSubItem = 1;
	rightCol.cx = 225;
	rightCol.pszText = _T ("Value");

	m_ListCtrl.InsertColumn (0, &leftCol);
	m_ListCtrl.InsertColumn (1, &rightCol);

	item.mask = LVIF_TEXT;
	item.iItem = 0;
	item.iSubItem = 0;
	item.pszText = _T ("Computer Name");
	m_ListCtrl.InsertItem (&item);
	tmpStr = m_bstrComputerName;
	m_ListCtrl.SetItemText (0, 1, tmpStr);

	item.iItem = 1;
	item.pszText = _T ("User Name");
	m_ListCtrl.InsertItem (&item);
	tmpStr = m_bstrUserName;
	m_ListCtrl.SetItemText (1, 1, tmpStr);

	item.iItem = 2;
	item.pszText = _T ("Local Language");
	m_ListCtrl.InsertItem (&item);
	tmpStr = m_bstrLocalLanguage;
	m_ListCtrl.SetItemText (2, 1, tmpStr);
}
