// SystemInformation.h : Declaration of the CSystemInformation

#ifndef __SYSTEMINFORMATION_H_
#define __SYSTEMINFORMATION_H_

#include "resource.h"       // main symbols
#import "..\Bin\SystemOS.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemMouse.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemMemory.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemHDisk.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemStorage.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemMultiMedia.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemCPU.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#import "..\Bin\SystemMisc.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids

/////////////////////////////////////////////////////////////////////////////
// CSystemInformation
class ATL_NO_VTABLE CSystemInformation : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSystemInformation, &CLSID_SystemInformation>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISystemInformation, &IID_ISystemInformation, &LIBID_SYSTEMINFOLib>
{
public:
	CSystemInformation();
	HRESULT FinalConstruct ();
	void FinalRelease ();

DECLARE_REGISTRY_RESOURCEID(IDR_SYSTEMINFORMATION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSystemInformation)
	COM_INTERFACE_ENTRY(ISystemInformation)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ISystemInformation
public:
	STDMETHOD(GetLocalLanguage)(/*[out]*/ BSTR *pbstrLocalLanguage);
	STDMETHOD(GetUserName)(/*[out]*/ BSTR *pbstrUserName);
	STDMETHOD(GetComputerName)(/*[out]*/ BSTR *pbstrComputerName);
	STDMETHOD(GetMultiMediaInformation)(/*[out]*/ VARIANT_BOOL *pbIsInstalled,
		/*[out]*/ VARIANT_BOOL *pbHasVolCtrl, /*[out]*/ VARIANT_BOOL *pbHasSeparateLRVolCtrl,
		/*[out]*/ BSTR *pbstrProductName, /*[out]*/ BSTR *pbstrCompanyName);
	STDMETHOD(GetStorageMediaInformation)(/*[out]*/ long *plNumberOfDrives,
		/*[out]*/ VARIANT *pbReadyArr,  /*[out]*/ VARIANT *pbstrDriveLetterArr,
		/*[out]*/ VARIANT *pbstrLabelArr, /*[out]*/ VARIANT *pbSupportLongNameArr,
		/*[out]*/ VARIANT *pbstrFileSystemArr, /*[out]*/ VARIANT *pbstrMediaTypeArr,
		/*[out]*/ VARIANT *plTotalSpaceArr, /*[out]*/ VARIANT *plFreeSpaceUserArr,
		/*[out]*/ VARIANT *plFreeSpaceTotalArr);
	STDMETHOD(GetMemoryInformation)(/*[out]*/ long *plRAMInstalled,
		/*[out]*/ long *plAvailableMemory, /*[out]*/ long *plVirtualMemory,
		/*[out]*/ long *plMemoryLoad);
	STDMETHOD(GetHDiskInformation)(/*[out]*/ long *plNumberOfPartitions,
		/*[out]*/ VARIANT *pbstrDriveLetterArr, /*[out]*/ VARIANT *pbBootableArr,
		/*[out]*/ VARIANT *pbstrTypeArr, /*[out]*/ VARIANT *plPartitionNumberArr,
		/*[out]*/ VARIANT *plLengthArr, /*[out]*/ VARIANT *plHiddenSectorsArr);
	STDMETHOD(GetCPUInformation)(/*[out]*/ BSTR *pbstrVendor, /*[out]*/ BSTR *pbstrType,
		/*[out]*/ BSTR *pbstrArchitecture, /*[out]*/ BSTR *pbstrLevel,
		/*[out]*/ BSTR *pbstrRevision, /*[out]*/ long *plNumberOfProcessors,
		/*[out]*/ long *plSpeed, /*[out]*/ long *plPageSize, /*[out]*/ long *plMask);
	STDMETHOD(GetMouseInformation)(/*[out]*/ VARIANT_BOOL *pbInstalled,
		/*[out]*/ VARIANT_BOOL *pbButtonsSwapped, /*[out]*/ long *plSpeed);
	STDMETHOD(GetOSInformation)(/*[out]*/ BSTR *pbstrPlatform, /*[out]*/ BSTR *pbstrMinorVersion,
		/*[out]*/ BSTR *pbstrServicePack, /*[out]*/ long *plBuildNumber);

	IOSInformation				*m_pOSInfo;
	IMouseInformation			*m_pMouseInfo;
	IMemoryInformation			*m_pMemoryInfo;
	IHDiskInformation			*m_pHDiskInfo;
	IStorageMediaInformation	*m_pStorageInfo;
	IMultiMediaInformation		*m_pMultiMediaInfo;
	ICPUInformation				*m_pCPUInfo;
	IMiscInformation			*m_pMiscInfo;
};

#endif //__SYSTEMINFORMATION_H_
