// MiscInformation.h : Declaration of the CMiscInformation

#ifndef __MISCINFORMATION_H_
#define __MISCINFORMATION_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CMiscInformation
class ATL_NO_VTABLE CMiscInformation : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMiscInformation, &CLSID_MiscInformation>,
	public ISupportErrorInfo,
	public IDispatchImpl<IMiscInformation, &IID_IMiscInformation, &LIBID_SYSTEMMISCLib>
{
public:
	CMiscInformation()
	{
		m_bInformationObtained = false;

		m_bstrComputerName = _T ("");
		m_bstrUserName = _T ("");
		m_bstrLocalLanguage = _T ("");
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MISCINFORMATION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMiscInformation)
	COM_INTERFACE_ENTRY(IMiscInformation)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMiscInformation
public:
	STDMETHOD(get_Language)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_UserName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ComputerName)(/*[out, retval]*/ BSTR *pVal);

private:
	bool m_bInformationObtained;

	CComBSTR m_bstrComputerName;
	CComBSTR m_bstrUserName;
	CComBSTR m_bstrLocalLanguage;

	HRESULT GetInformation ();
};

#endif //__MISCINFORMATION_H_
