// MouseInformation.h : Declaration of the CMouseInformation

#ifndef __MOUSEINFORMATION_H_
#define __MOUSEINFORMATION_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CMouseInformation
class ATL_NO_VTABLE CMouseInformation : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMouseInformation, &CLSID_MouseInformation>,
	public ISupportErrorInfo,
	public IDispatchImpl<IMouseInformation, &IID_IMouseInformation, &LIBID_SYSTEMMOUSELib>
{
public:
	CMouseInformation()
	{
		m_bInformationObtained = false;
		m_bIsInstalled = FALSE;
		m_bAreButtonsSwapped = FALSE;
		m_lSpeed = 0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MOUSEINFORMATION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMouseInformation)
	COM_INTERFACE_ENTRY(IMouseInformation)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMouseInformation
public:
	STDMETHOD(GetMouseInformation)(/*[out]*/ VARIANT_BOOL *pbInstalled,
		/*[out]*/ VARIANT_BOOL *pbButtonsSwapped, /*[out]*/ long *plSpeed);
	STDMETHOD(get_Speed)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_AreButtonsSwapped)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_IsInstalled)(/*[out, retval]*/ VARIANT_BOOL *pVal);

	VARIANT_BOOL m_bIsInstalled;
	VARIANT_BOOL m_bAreButtonsSwapped;
	long m_lSpeed;

private:
	bool m_bInformationObtained;
	HRESULT GetInformation ();
};

#endif //__MOUSEINFORMATION_H_
