VERSION 5.00
Begin VB.Form frmMapConverter 
   Caption         =   "Map Converter"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmMapConverter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const MaxX As Integer = 50
Const MaxY As Integer = 50
Const MaxLayers As Integer = 10

Const Tiles As Integer = 0
Const Targets As Integer = 1
Const Objects As Integer = 2
Const ObjectIndex As Integer = 3
Const Unknown As Integer = 4
Const Doors As Integer = 5
Const EntryPoints As Integer = 6

Const NoDoor As Integer = -1
Const ClosedDoor As Integer = 1
Const OpenDoor As Integer = 2
Const ClosedDoorVertical As Integer = 0
Const OpenDoorVertical As Integer = 1
Const ClosedDoorHorizontal As Integer = 2
Const OpenDoorHorizontal As Integer = 3

Const NoTarget As Integer = 0
Const CAT As Integer = 27
Const Damping_Controls As Integer = 28
Const Hulk_Archive As Integer = 34
Const Toxin_Canister As Integer = 35
' vv DT
Const Cargo_Bay_Controls As Integer = 36
' ^^ DT

Const NoObject As Integer = 0
Const Marine As Integer = 1
Const Stealer As Integer = 2
Const BLIP As Integer = 3
Const CONSOLE_1 As Integer = 4
Const CONSOLE_2 As Integer = 5
Const CONSOLE_3 As Integer = 6
Const SPLAT As Integer = 9 ' not used in mapper
Const AIRPUMP_1 As Integer = 10
Const AIRPUMP_2 As Integer = 11
Const AIRPUMP_3 As Integer = 12
Const AIRPUMP_4 As Integer = 13

Const NoEntry As Integer = 0
Const StealerEntry As Integer = 1

Const Squad1 As Integer = 10
Const Squad2 As Integer = 11
Const Squad3 As Integer = 12
Const Squad4 As Integer = 13
Const Squad5 As Integer = 14
Const MarineExit As Integer = 15


Const TILE_BLIP As Integer = 32
Const TILE_STEALER_ENTRY As Integer = 31
Const TILE_MARINE_1_ENTRY As Integer = 33
Const TILE_MARINE_2_ENTRY As Integer = 34
Const TILE_MARINE_EXIT As Integer = 35

' This is a problem! Two constant for the one thing...
Const TILE_CAT As Integer = 36
Const TILE_DAMPING_CONTROLS As Integer = 37
Const TILE_HULK_ARCHIVE As Integer = 38
Const TILE_TOXIN_CANISTER As Integer = 39
Const TILE_CARGO_BAY_CONTROLS As Integer = 70
Const TILE_CRYO_NW As Integer = 78
Const TILE_CRYO_NE As Integer = 79
Const TILE_CRYO_SE As Integer = 80
Const TILE_CRYO_SW As Integer = 81

Dim TilesX As Integer
Dim TilesY As Integer
Dim MaxXUsed As Integer
Dim MaxYUsed As Integer
Dim MinXUsed As Integer
Dim MinYUsed As Integer

Dim XOffset As Integer
Dim YOffset As Integer

Dim iMapTiles(MaxX, MaxY, MaxLayers) As Integer

Public Campaign As Integer
Public Mission As Integer

Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim objFile As Variant, strFile As String, strXML As String

    For Each objFile In Data.Files
        strFile = CStr(objFile)
        Debug.Print strFile

        ReadMap strFile
        strXML = Left(strFile, (Len(strFile) - 3)) & "xml"
        ExportMap strXML
    Next objFile
End Sub

Public Sub ReadMap(strMapName As String)
    Dim iHdr As Integer

    If Len(strMapName) = 0 Then Return

    Open strMapName For Binary Access Read As 1

    Get #1, 1, iHdr

    ' The header is like a version number of map file format.
    ' 1 = original format
    ' 2 = campaign and mission number added

    If iHdr > 1 Then
        Get #1, , Campaign
        Get #1, , Mission
    End If

    Get #1, , MinXUsed
    Get #1, , MaxXUsed
    Get #1, , MinYUsed
    Get #1, , MaxYUsed
    Get #1, , iMapTiles

    Close 1
End Sub

Private Sub ExportMap(strXML As String)
    Dim fn As Integer
    Dim indentLevel As Integer
    Dim x As Integer
    Dim y As Integer
    Dim cellStr As String
    Dim rowStr As String
    Dim printParent As Boolean
    Dim parentPrinted As Boolean

    indentLevel = 0
    fn = FreeFile
    Open strXML For Output Access Write As #fn

    Print #fn, "<mission campaign=""" & Campaign & """ number=""" & Mission & """>"
    indentLevel = indentLevel + 2
    Print #fn, Spc(indentLevel); "<tiles>"
    indentLevel = indentLevel + 2

    '
    ' write the floor and wall tiles
    '
    Print #fn, Spc(indentLevel); "<floor>"
    indentLevel = indentLevel + 2

    For y = 0 To (MaxY - 1)
        Print #fn, Spc(indentLevel); "<row rowNumer=""" & y & """"
        indentLevel = indentLevel + 2
        rowStr = ""
        For x = 0 To (MaxX - 1)
            cellStr = Hex(iMapTiles(x, y, Tiles))
            If Len(cellStr) = 1 Then cellStr = "0" & cellStr
            rowStr = rowStr & cellStr
        Next x
        Print #fn, Spc(indentLevel); "   floorTiles=""" & rowStr & """"

        rowStr = ""
        For x = 0 To (MaxX - 1)
            If iMapTiles(x, y, Targets) > 0 And iMapTiles(x, y, Targets) < 27 Then
                cellStr = Hex(iMapTiles(x, y, Targets))
                If Len(cellStr) = 1 Then cellStr = "0" & cellStr
                rowStr = rowStr & cellStr
            Else
                rowStr = rowStr & "00"
            End If
        Next x
        Print #fn, Spc(indentLevel); "   wallTiles=""" & rowStr & """";

        indentLevel = indentLevel - 2
        Print #fn, " />"
    Next y

    indentLevel = indentLevel - 2
    Print #fn, Spc(indentLevel); "</floor>"


    '
    ' write the targets
    '
    printParent = True
    parentPrinted = False
    'Print #fn, Spc(indentLevel); "<targets>"
    indentLevel = indentLevel + 2
    For y = 0 To (MaxY - 1)
        For x = 0 To (MaxX - 1)
            If iMapTiles(x, y, Targets) > 26 Then
                Select Case iMapTiles(x, y, Targets)
                    Case Cargo_Bay_Controls:
                        cellStr = "Cargo Bay Controls"
                    Case CAT:
                        cellStr = "C.A.T."
                    Case Damping_Controls:
                        cellStr = "Damping Controls"
                    Case Hulk_Archive:
                        cellStr = "Hulk Archive"
                    Case Toxin_Canister:
                        cellStr = "Toxin Canister"
                End Select
                If printParent = True Then
                    Print #fn, Spc(indentLevel - 2); "<targets>"
                    printParent = False
                    parentPrinted = True
                End If
                Print #fn, Spc(indentLevel); "<target x=""" & x & """ y=""" & y & """ id=""" & iMapTiles(x, y, Targets) & """ description=""" & cellStr & """ />"
            End If
        Next x
    Next y
    indentLevel = indentLevel - 2
    If parentPrinted = True Then
        Print #fn, Spc(indentLevel); "</targets>"
    End If


    '
    ' write the objects - can only place blips, console and airpump in mapper
    '
    printParent = True
    parentPrinted = False
    'Print #fn, Spc(indentLevel); "<objects>"
    indentLevel = indentLevel + 2
    For y = 0 To (MaxY - 1)
        For x = 0 To (MaxX - 1)
            cellStr = ""
            Select Case iMapTiles(x, y, Objects)
                Case BLIP:
                    cellStr = "Blip"
                Case CONSOLE_1:
                    cellStr = "Console part-1"
                Case CONSOLE_2:
                    cellStr = "Console part-2"
                Case CONSOLE_3:
                    cellStr = "Console part-3"
                Case AIRPUMP_1:
                    cellStr = "Air pump part-1"
                Case AIRPUMP_2:
                    cellStr = "Air pump part-2"
                Case AIRPUMP_3:
                    cellStr = "Air pump part-3"
                Case AIRPUMP_4:
                    cellStr = "Air pump part-4"
            End Select

            If cellStr <> "" Then
                If printParent = True Then
                    Print #fn, Spc(indentLevel - 2); "<objects>"
                    printParent = False
                    parentPrinted = True
                End If
                Print #fn, Spc(indentLevel); "<target x=""" & x & """ y=""" & y & """ id=""" & iMapTiles(x, y, Objects) & """ description=""" & cellStr & """ />"
            End If
        Next x
    Next y
    indentLevel = indentLevel - 2
    If parentPrinted = True Then
        Print #fn, Spc(indentLevel); "</objects>"
    End If


    '
    ' write the doors
    '
    Print #fn, Spc(indentLevel); "<doors>"
    indentLevel = indentLevel + 2
    For y = 0 To (MaxY - 1)
        For x = 0 To (MaxX - 1)
            If iMapTiles(x, y, Doors) > -1 And iMapTiles(x, y, Doors) < 3 Then
                If iMapTiles(x, y, Doors) = 1 Then
                    cellStr = "closed"
                Else
                    cellStr = "open"
                End If
                
                If iMapTiles(x, y, Tiles) = 0 Then
                    Print #fn, Spc(indentLevel); "<bulkhead x=""" & x & """ y=""" & y & """ state=""" & cellStr & """ />"
                Else
                    Print #fn, Spc(indentLevel); "<door x=""" & x & """ y=""" & y & """ state=""" & cellStr & """ />"
                End If
            End If
        Next x
    Next y
    indentLevel = indentLevel - 2
    Print #fn, Spc(indentLevel); "</doors>"


    '
    ' write the entries/exits
    '
    Print #fn, Spc(indentLevel); "<entryPoints>"
    indentLevel = indentLevel + 2
    For y = 0 To (MaxY - 1)
        For x = 0 To (MaxX - 1)
            Select Case iMapTiles(x, y, EntryPoints)
                Case StealerEntry:
                    Print #fn, Spc(indentLevel); "<stealerEntry x=""" & x & """ y=""" & y & """ />"
                Case Squad1:
                    Print #fn, Spc(indentLevel); "<marineEntry x=""" & x & """ y=""" & y & """ squad=""1"" />"
                Case Squad2:
                    Print #fn, Spc(indentLevel); "<marineEntry x=""" & x & """ y=""" & y & """ squad=""2"" />"
                Case MarineExit:
                    Print #fn, Spc(indentLevel); "<marineExit x=""" & x & """ y=""" & y & """ />"
            End Select
        Next x
    Next y
    indentLevel = indentLevel - 2
    Print #fn, Spc(indentLevel); "</entryPoints>"


    indentLevel = indentLevel - 2
    Print #fn, Spc(indentLevel); "</tiles>"
    indentLevel = indentLevel - 2
    Print #fn, "</mission>"

    Close #fn
End Sub

